#include <Python.h>

#if PY_MAJOR_VERSION >= 3
#define IS_PY3K
#endif


static PyObject *
fib(PyObject *self, PyObject *args)
{
      int a = 0, b = 1, c, n;


      if (!PyArg_ParseTuple(args, "i", &n))
             return NULL;


      PyObject *list = PyList_New(0);

      while(b < n){
             PyList_Append(list, PyLong_FromLong(b));
             c = a+b;
             a = b;
             b = c;
      }

      return list;
}

PyMethodDef fib_methods[] = {
       {"fib", fib, METH_VARARGS, "Returns a fibonacci sequence as a list"},
           {NULL, NULL, 0, NULL}
};

#ifdef IS_PY3K
struct module_state {
   PyObject *error;
};

#define GETSTATE(m) ((struct module_state*)PyModule_GetState(m))

static int fib_traverse(PyObject *m, visitproc visit, void *arg) {
    Py_VISIT(GETSTATE(m)->error);
    return 0;
}

static int fib_clear(PyObject *m) {
    Py_CLEAR(GETSTATE(m)->error);
    return 0;
}

static struct PyModuleDef moduledef = {
        PyModuleDef_HEAD_INIT,
        "fib",
        NULL,
        sizeof(struct module_state),
        fib_methods,
        NULL,
        fib_traverse,
        fib_clear,
        NULL
};

PyObject * PyInit_fib(void)
{
   PyObject *module = PyModule_Create(&moduledef);
   return module;
}

#else

void initfib(void)
{
   (void) Py_InitModule("fib", fib_methods);
}

#endif

